/***************************************************************************

        Auticko - ui_fn.c

        copyright (C) 2002 by Josef Kufner <jkufner@seznam.cz>


     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

***************************************************************************/

#include <stdlib.h>
#include <ncurses.h>		/* Kvuli definicim klaves KEY_* */

#include "ui_fn.h"
#include "ui.h"
#include "auticko.h"

#define TOGGLE(x)	x = (x == 0)

UI_FN main_ui[] = {
/*		key, joystick,	fn,		title,		keyname*/
	{	' ', 0,		fn_stop,	"Stop",		"space"},
	{	KEY_UP, 0,	fn_go_up,	"Je Vped",	"Up"},
	{	KEY_DOWN, 0, 	fn_go_down,	"Je Zpt",	"Down"},
	{	KEY_LEFT, 0,	fn_go_left,	"Je Vlevo",	"Left"},
	{	KEY_RIGHT, 0,	fn_go_right,	"Je Vpravo",	"Right"},
	{	0, 0,		NULL,		"",		""},
	{	'h', 0,		fn_horn,	"Houkaka",	"h"},
	{	'l', 0,		fn_light,	"Svtla",	"l"},
	{	0, 0,		NULL,		"",		""},
	{	'.', 0,		fn_blink_right,	"Blinkr vpravo","."},
	{	',', 0,		fn_blink_left,	"Blinkr vlevo",	","},
	{	0, 0,		NULL,		"",		""},
	{	'q', 0,		fn_Konec,	"Konec",	"q"},
	{	0, 0,		NULL,		NULL,		NULL }
	
}; 

int smer = 0;

void fn_stop (void) {
	ui_Terminal(T_OK "Stop.\n");
	pict_val.up = 0;
	pict_val.down = 0;
	Auticko_Send_Command(CMD_STOP, 0);
}

void fn_go_up (void) {
	ui_Terminal("Go - Vped.\n");
	pict_val.up = 1;
	pict_val.down = 0;
	Auticko_Send_Command(CMD_GO, 1);
}

void fn_go_down (void) {
	ui_Terminal("Go - Zpt\n");
	pict_val.up = 0;
	pict_val.down = 1;
	Auticko_Send_Command(CMD_GO, 0);
}

void fn_go_left (void) {
	if (smer > -1)
		smer--;
	
	pict_val.left = (unsigned) smer;
	pict_val.right = 0;
	ui_Terminal(T_ERR "fn_go_left: not implemented\n");
/*	Auticko_Send_Command(CMD_LEFT, (unsigned) smer); */
}

void fn_go_right (void) {
	if (smer < 1)
		smer++;
	
	pict_val.right = (unsigned)smer;
	pict_val.left = 0;
	ui_Terminal(T_ERR "fn_go_right: not implemented\n");
/*	Auticko_Send_Command(CMD_RIGHT, (unsigned) smer); */
}

void fn_horn (void) {
	ui_Terminal(T_ERR "fn_horn: not implemented\n");
}

void fn_light (void) {
	TOGGLE(pict_val.light);
	ui_Terminal(T_ERR "fn_light: not implemented\n");
}

void fn_blink_left (void) {
	TOGGLE(pict_val.l_blink);
	ui_Terminal(T_ERR "fn_blink_left: not implemented\n");
}

void fn_blink_right (void) {
	TOGGLE(pict_val.r_blink);
	ui_Terminal(T_ERR "fn_blink_right: not implemented\n");
}

void fn_Konec (void) {
	ui_Terminal("Exit...");
	exit(0);
}
